/**
 * Admin Script
 **/

(function($){
    
    //Main
    function iptrank_main(){};
    //Keyword function
    iptrank_main.prototype.keyword = function()
    {
        var $this = this;
        
        /*
         * Add keyword handler
         */
        var form = new ip_form( '#iptrank-add-keywords-form' );
        form.validator = function()
        {
            var error = 0;
            if ( this.check_empty( '#iptrank-input-site', iptrank_mng_msg.site_empty ) ) {
                error++;
            }
            if ( this.check_empty( '#iptrank-input-keywords', iptrank_mng_msg.keywords_empty ) ) {
                error++;
            }
            if ( this.check_empty( '#iptrank-input-group', iptrank_mng_msg.group_empty ) ) {
                error++;
            }
            if ( error < 1 ) {
                return true;
            }
            return false;
        };
        form.ajax_success= function( result, object ) 
        {
            $( '.ui-message', object.form ).remove();
            ip_ui.loader.hide();
            if ( result.status == 1 ) 
            {
                var table = $( '#iptrank-keywords-manage' );
                
                var temp = $( result.content );
                temp.find( '.iptrank-keyword-delete' ).each( function()
                {
                    $(this).click( function()
                    {
                        var url = ajaxurl+'?doajax=1&iptrank=1&action=iptrank_delete_keyword';
                        ip_ui.delete_confirm.set_ajax( url );
                        ip_ui.delete_confirm.show( $(this) );
                        return false;
                    });
                });
                temp.find( '.iptrank-keyword-update' ).each( function(){
                    $this.update_rank( $(this) );
                });
                
                $( '#the-list .no-items', table ).hide();
                $( '#the-list', table ).append( temp );
                var popup = $( '#iptrank-popup-keywords' );
                ip_ui.modal.popup_hide( popup );
                ip_ui.message.modal( result.message, 'alert-success' );
            }
            else {
                ip_ui.message.modal( result.message, 'alert-danger' );
            }
        }
        form.init();
        
        /*
         * Add new group in keyword
         */
        $( '.addgroup-btn' ).click( function()
        {
            var form = $(this).parents( 'form' );
            $( '.iptrank-field-newgroup', form ).show();
            return false;
        });
        
        /*
         * Delete rank
         */
        $( '.iptrank-keyword-delete' ).each( function(){
            $(this).click( function()
            {
                var url = ajaxurl+'?doajax=1&iptrank=1&action=iptrank_delete_keyword';
                ip_ui.delete_confirm.set_ajax( url );
                ip_ui.delete_confirm.show( $(this) );
                return false;
            });
        });
        
        /*
         * Update rank
         */
        $( '.iptrank-keyword-update' ).each( function(){
            $this.update_rank( $(this) );
        });
        
        /*
         * View rank
         */
        $( '#iptrank-keywords-manage #the-list tr:first-child' ).addClass( 'viewed' );
        $( '.iptrank-keyword-view' ).each( function(){
            $this.get_rank_report( $(this) );
        });
        
        /*
         * Bulk Actions
         */
        $( '#iptrank-doaction' ).click( function()
        {
            var val  = $( '#iptrank-action-name' ).val();
            var btn  = $(this);
            var root = btn.parents( 'form' );
            
            btn.attr( 'disabled', 'disabled' );
            
            var values = $( 'input[name="rank[]"]:checked', root );
            if ( values.length > 0 ) 
            {
                var ids = '';
                values.each( function(){
                    ids += $(this).val() + ',';
                });
                if ( val == 'update' ) 
                {
                    $this.update_ranks( ids, values, root );
                }
                else if ( val == 'delete' )
                {
                    $this.delete_ranks( ids, values, root );
                }
            
            }
            return false;
        });
        
    };
    
    iptrank_main.prototype.get_rank_report = function( button )
    {
        button.click( function()
        {
            var report = $( '#iptrank-keyword-reports' );
            var table  = button.parents( 'table' ); 
            var tr     = button.parents( 'tr' ); 
            var id     = button.attr( 'href' ).replace( '#toView_', '' );
            
            $( '.iptrank-section-full-loader', report ).show();
            $( '.iptrank-keyword-view', table ).addClass( 'disabled' ); 
            $( '.iptrank-keyword-view', table ).attr( 'disabled', 'disabled' ); 
            
            //Get chart via ajax
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrank=1&action=iptrank_rank_report',
                type: "POST",
                data: 'rankid='+id,
                dataType: "html",
                success: function (result ) 
                {
                    if ( result.length > '20' )
                    {
                        $( '.iptrank-manage-tab', report ).html( result );
                        $( 'tbody tr', table ).removeClass( 'viewed' ); 
                        tr.addClass( 'viewed' ); 
                    }
                    $( '.iptrank-keyword-view', table ).removeClass( 'disabled' ); 
                    $( '.iptrank-keyword-view', table ).removeAttr( 'disabled' ); 
                    $( '.iptrank-section-full-loader', report ).hide();
                    
                    //Go to
                    ip_ui.loader.go_to( '#iptrank-keyword-reports' );
                },
                error: function () {
                    alert( "Error in get statistic data" );
                    $( '.iptrank-keyword-view', table ).removeClass( 'disabled' ); 
                    $( '.iptrank-keyword-view', table ).removeAttr( 'disabled' ); 
                    $( '.iptrank-section-full-loader', report ).hide();
                },
            });
            return false;
        });
    };
    
    /*
     * Update rank
     */
    iptrank_main.prototype.update_rank = function( button )
    {
        button.click( function()
        {
            var tr  = button.parents( 'tr' );
            var id  = button.attr( 'href' ).replace( '#toUpdate_', '' );
            var url = ajaxurl+'?doajax=1&iptrank=1&action=iptrank_update_rank';
            
            //Show spinner
            $( '.iptrank-update-status .iptrank-spinner', tr ).show();
            $( '.iptrank-update-status .iptrank-last', tr ).hide();
            //Disabled button
            button.addClass( 'ipadm-btn-disabled' ).attr( 'disabled', 'disabled' );
            
            $.ajax({
                url: url,
                type: "POST",
                dataType: "json",
                data: 'id='+id,
                success: function( result ) {
                    if ( result.status == 1 ) {
                        $( '.rank', tr ).html( result.rank );
                    }
                    //Hide spinner
                    $( '.iptrank-update-status .iptrank-spinner', tr ).hide();
                    $( '.iptrank-update-status .iptrank-last', tr )
                        .text( result.date )
                        .show();
                    button.removeClass( 'ipadm-btn-disabled' ).removeAttr( 'disabled' );
                }
            });
            return false;
        });
    };
    
    /*
     * Update multiple ranks
     */
    iptrank_main.prototype.update_ranks = function( ids, values, root )
    {
        values.each( function()
        {
            var id = $(this).val();
            var cb = $( '#cb-select-' + id );
            var tr = cb.parents( 'tr' );
            
            $( '.iptrank-update-status .iptrank-last', tr ).hide();
            $( '.iptrank-update-status .iptrank-spinner', tr ).show();
            $( '.iptrank-keyword-update', tr )
                .addClass( 'ipadm-btn-disabled' ).attr( 'disabled', 'disabled' );
            
        });
        
        $.ajax({
            url: ajaxurl+'?doajax=1&iptrank=1&action=iptrank_update_ranks',
            type: "POST",
            dataType: "json",
            data: 'ids='+ids,
            success: function( result ) 
            {
                values.each( function()
                {
                    var id = $(this).val();
                    var cb = $( '#cb-select-' + id );
                    var tr = cb.parents( 'tr' );
                    
                    $( '.iptrank-update-status .iptrank-last', tr ).show();
                    $( '.iptrank-update-status .iptrank-spinner', tr ).hide();
                    $( '.iptrank-keyword-update', tr )
                        .removeClass( 'ipadm-btn-disabled' ).removeAttr( 'disabled' );
                    
                    if ( result.status == '1' )
                    {
                        if ( typeof result['data'][id] != 'undefined' ) {
                            $( '.iptrank-update-status .iptrank-last', tr ).text( result['data'][id].date );
                            $( '.rank', tr ).html( result['data'][id].rank );
                        }
                    }
                });
                $( '#iptrank-doaction', root ).removeAttr( 'disabled' );
            }
        });
    };
    
    /*
     * Delete multiple ranks
     */
    iptrank_main.prototype.delete_ranks = function( ids, values, root )
    {
        //Text conf
        var delete_confirm_title = '';
        var delete_confirm_info  = '';
        if (typeof ip_ui_message.delete_confirm_title != 'undefined') {
            delete_confirm_title = ip_ui_message.delete_confirm_title;
        }
        if (typeof ip_ui_message.delete_confirm_info != 'undefined') {
            delete_confirm_info = ip_ui_message.delete_confirm_info;
        }
        
        ip_ui.delete_bulk = new ip_ui.base.confirm();
        ip_ui.delete_bulk.set_vars({
            title:      delete_confirm_title,
            info:       delete_confirm_info,
            yes_class:  'ipadm-btn ipadm-btn-danger',
            no_class:   'ipadm-btn ipadm-btn-default',
            action:     function( object, ui )
            {
                ip_ui.loader.show();
                ui.hide( object );
                
                $.ajax({
                    url: ui.ajax_url + '&ids='+ids,
                    type: "POST",
                    dataType: "json",
                    success: function (result) 
                    {
                        if ( result.status == '-1' ) {
                            ip_ui.message.modal( result.message, 'alert-danger' );
                        } else 
                        {
                            ip_ui.message.modal( result.message, 'alert-success' );
                            values.each( function()
                            {
                                var id = $(this).val();
                                var cb = $( '#cb-select-' + id );
                                var tr = cb.parents( 'tr' );
                                tr.hide( 'blind' );
                                setTimeout( function(){
                                    tr.remove();
                                }, 600);
                            
                            });
                        }
                        $( '#iptrank-doaction', root ).removeAttr( 'disabled' );
                        ip_ui.loader.hide();
                    },
                    error: function () {
                        alert( "Error in deleting keyword." );
                    },
                });
            }
        });
        
        var url = ajaxurl+'?doajax=1&iptrank=1&action=iptrank_delete_keywords';
        ip_ui.delete_bulk.set_ajax( url );
        ip_ui.delete_bulk.show( $(this) );
    };
    
    //Group function
    iptrank_main.prototype.group = function()
    {
        /*
         * Save group handler
         */
        var form_add = new ip_form( '#iptrank-add-group-form' );
        form_add.is_add = true;
        //Validator
        form_add.validator = function()
        {
            var error = 0;
            if ( this.check_empty( '#iptrank-input-name', iptrank_group_msg.name_empty ) ) {
                error++;
            }
            if ( error < 1 ) {
                return true;
            }
            return false;
        };
        //Additional data
        form_add.additional_data = function( data )
        {
            if ( this.is_add ) {
                data += '&isadd=1';
            }
            return data;
        };
        form_add.init();
        
        var form_edit = new ip_form( '#iptrank-edit-group-form' );
        form_edit.is_add = false;
        form_edit.init();
        
        /*
         * Delete group
         */
        $( '.iptrank-group-delete' ).each( function(){
            $(this).click( function()
            {
                var url = ajaxurl+'?doajax=1&iptrank=1&action=iptrank_delete_group';
                ip_ui.delete_confirm.set_ajax( url );
                ip_ui.delete_confirm.show( $(this) );
                return false;
            });
        });
    };
    
    //Research function
    iptrank_main.prototype.research = function()
    {
        /*
         * Search keyword
         */
        var root = $( '#iptrank-research' );
        var form = new ip_form( '#iptrank-research-form' );
        //Validator
        form.validator = function()
        {
            var error = 0;
            if ( this.check_empty( '#iptrank-input-keyword', iptrank_research_msg.keyword_empty ) ) {
                error++;
            }
            if ( error < 1 ) {
                return true;
            }
            return false;
        };
        form.ajax_dataType = 'html';
        form.ajax_success  = function( result, $this )
        {
            ip_ui.loader.hide();
            if ( result.length > 10 ) {
                $( '.iptrank-result-empty', root ).hide();
                $( '.iptrank-result-top', root ).show();
                $( '.iptrank-result-bottom', root ).show();
                $( '.iptrank-result-main', root ).html( result ).show();
                
                var count = $(result).find('li').length;
                var end   = new Number( count );
                var start = 0;
                
                var interval = setInterval( function()
                {
                    if ( start >= end ) {
                        clearInterval(interval);
                    }
                    $( '.iptrank-result-top strong', root ).text(start);
                    start++;
                }, 50 );
                
                //Check all
                $( '#iptrank-research-result' ).check_all();
            }
        };
        form.after = function()
        {
            var kwd = $( '#iptrank-input-keyword' ).val();
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrank=1&action=iptrank_research_list',
                type: "POST",
                data: 'keyword='+kwd,
                dataType: "html",
                success: function (result ) 
                {
                    if ( result.length > 10 )
                    {
                        $( '#iptrank-research-result-list' ).val( result );
                    }
                    search_progress = false;
                }
            });
        };
        form.init();
        
        /*
         * Autocompletion input keyword
         */
        var search_progress = false;
        $( '#iptrank-input-keyword', root ).keyup( function()
        {
            if ( search_progress ) {
                return true;
            }
            search_progress = true;
            
            var kwd = $(this).val();
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrank=1&action=iptrank_research_input',
                type: "POST",
                data: 'keyword='+kwd,
                dataType: "html",
                success: function (result ) 
                {
                    if ( result.length > 10 )
                    {
                        $( '.iptrank-result-empty', root ).hide();
                        $( '.iptrank-result-top', root ).show();
                        $( '.iptrank-result-bottom', root ).show();
                        $( '.iptrank-result-main', root ).html( result ).show();
                        
                        var count = $(result).find('li').length;
                        var end   = new Number( count );
                        var start = 0;
                        
                        var interval = setInterval( function()
                        {
                            if ( start >= end ) {
                                clearInterval(interval);
                            }
                            $( '.iptrank-result-top strong', root ).text(start);
                            start++;
                        }, 50 );
                        
                        //Check all
                        $( '#iptrank-research-result' ).check_all();
                    }
                    search_progress = false;
                }
            });
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrank=1&action=iptrank_research_input_list',
                type: "POST",
                data: 'keyword='+kwd,
                dataType: "html",
                success: function (result ) 
                {
                    if ( result.length > 10 )
                    {
                        $( '#iptrank-research-result-list' ).val( result );
                    }
                    search_progress = false;
                }
            });
        });
    };
    
    //Setting function
    iptrank_main.prototype.setting = function()
    {
        /*
         * Search setting
         */
        var root = $( '#iptrank-setting' );
        var form = new ip_form( '#iptrank-setting-form' );
        form.init();
    };
    
    //Run main function
    iptrank_main.prototype.run = function()
    {
        this.keyword();
        this.group();
        this.research();
        this.setting();
    };
    
    //Tab Menu
    $.fn.iptrank_tabMenu = function(options){
        this.each( function(){
            var root = $(this);
            
            tabMenuInit();
            
            $( '.iptrank-tab-menu a', root ).click( function(){
                clearLinkClick( $(this) );
                var cont = $( this ).parents( '.iptrank-tab-menu' );
                cont.addClass( 'current' );
                
                var idtab = $(this).attr( 'href' ).replace( '#', '' );
                $( '#'+idtab ).show();
                $( '#iptrank-tab-selected' ).val( idtab );
                
                if ( idtab == 'iptrank-tab-stats' ) {
                    $( '#iptrank-save' ).hide();
                } else {
                    $( '#iptrank-save' ).show();
                }
                
                return false;
            });
            
            function clearLinkClick() 
            {
                $( '.iptrank-tab-menu', root ).each( function(){
                    $(this).removeClass( 'current' );
                });
                $( '.iptrank-tab-section', root ).hide();
            };
            
            function tabMenuInit() 
            {
                clearLinkClick();
                $( '.iptrank-tab-section', root ).hide();
                var current = $( '#iptrank-tab-selected' ).val();
                $( '#'+current ).show();
                $( 'a[href="#'+current+'"]' ).parents('.iptrank-tab-menu').addClass( 'current' );
                $( '#iptrank-tab-selected' ).val( current );
            };
        });
    };
    
    $.fn.check_all = function( options )
    {
        var root = $(this);
        $( '.trigger', root ).click( function()
        {
            var count   = $( '.check-all', root ).length;
            var checked = $( '.check-all:checked', root ).length;
            if ( $(this).is( ':checked' ) ) {
                $( '.check-all', root ).attr( 'checked', 'checked' );
            } else {
                $( '.check-all', root ).removeAttr( 'checked' );
            }
        });
    };
    
    $(document).ready(function()
    {
        //Main function
        var main = new iptrank_main();
        main.run();
        
        //Link modal
        $( '.iptrank-btn-modal' ).ip_modal();
        
        //Tab menu
        $( '.iptrank-manage-tab' ).iptrank_tabMenu();
        
        //Report filter
        $( '.iptrank-report-filter #iptrank-input-date' ).change( function()
        {
            var selected = $(this).val();
            if ( selected == 1 ) {
                $( '#iptrank-field-month' ).show();
            } else {
                $( '#iptrank-field-month' ).hide();
            }
        });
        
        //Check all input checkbox
        $( '#iptrank-research-result' ).check_all();
        
        //Datetime picker
        var root = $( '#iptrank-log-filter-fields' );
        if ( root.length > 0 ) {
            $( '#iptrank-date-start', root )
                .datepicker()
                .bind('changeDate', function(ev){
                    $( '#iptrank-date-start', root ).datepicker('hide');
                });
                    
            $( '#iptrank-date-end', root )
                .datepicker()
                .bind('changeDate', function(ev){
                    $( '#iptrank-date-end', root ).datepicker('hide');
                });
        }
    });
    
})(jQuery);